import { createTheme, ThemeProvider } from '@mui/material/styles';
import { configureStore } from '@reduxjs/toolkit';
import { ComponentMeta, ComponentStory } from '@storybook/react';
import colorPaletteConfigSlice from 'libs/shared/data-access/store/src/lib/colorPaletteConfigSlice';
import { Provider } from 'react-redux';
import SemanticSubstrates from './semanticsubstrates';

export default {
  /* 👇 The title prop is optional.
   * See https://storybook.js.org/docs/react/configure/overview#configure-story-loading
   * to learn how to generate automatic titles
   */
  title: 'SemanticSubstrates',
  component: SemanticSubstrates,
  decorators: [
    (story) => <div style={{ padding: '3rem' }}>{story()}</div>,
    (story) => (
      <div style={{ padding: '3rem' }}>
        <Provider store={Mockstore}>{story()}</Provider>
      </div>
    ),
    (story) => <ThemeProvider theme={mockTheme}>{story()}</ThemeProvider>,
  ],
} as ComponentMeta<typeof SemanticSubstrates>;

// declare module '@mui/material/styles' {
//   interface Theme {
//     palette: {
//       primary: string;
//       dataPointColors: string[];
//     };
//   }
//   // allow configuration using `createTheme`
//   interface ThemeOptions {
//     palette: {
//       danger: string;
//       dataPointColors: string[];
//     };
//   }
// }

const mockTheme = createTheme({
  palette: {
    // danger: 'orange',
    dataPointColors: ['blue', 'green'],
  },
});

// A super-simple mock of a redux store
const Mockstore = configureStore({
  reducer: {
    colorPaletteConfig: colorPaletteConfigSlice,
  },
});

const Template: ComponentStory<typeof SemanticSubstrates> = (args) => (
  <SemanticSubstrates />
);

export const Primary = Template.bind({});

Primary.args = {
  content: 'Testing header #1',
};

export const Secondary = Template.bind({});

Secondary.args = {
  content: 'Testing header number twoooo',
};
