import { TypedUseSelectorHook, useDispatch, useSelector } from 'react-redux';
import { selectGraphQueryResult } from './graphQueryResultSlice';
import { selectSchema } from './schemaSlice';
import type { RootState, AppDispatch } from './store';

// Use throughout your app instead of plain `useDispatch` and `useSelector`
export const useAppDispatch = () => useDispatch<AppDispatch>();
export const useAppSelector: TypedUseSelectorHook<RootState> = useSelector;

// Gives the graphQueryResult from the store
export const useGraphQueryResult = () => useAppSelector(selectGraphQueryResult);

// Gives the schema form the store (as a graphology object)
export const useSchema = () => useAppSelector(selectSchema);
